<?php

namespace App\Http\Requests;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Validation\ValidationException;
use Illuminate\Http\Exceptions\HttpResponseException;

/**
 * @property mixed categories
 * @property mixed email
 * @property mixed message
 * @property mixed articles
 * @property mixed subject
 */
class NewsletterRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (Auth::guest()) {
            return true;
        }

        if (! Auth::check()) {
            return false;
        }

        if(Auth::user()->role == 'admin' )
        {
            return true;
        }

        if(Auth::user()->hasModule( 'newsletters' ) )
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules = [];

        if (Auth::user() && Auth::user()->role == 'admin' ){
            $admin_rules = [
                'email' => 'required|email',
                'subject' => 'sometimes|min:3',
                'message' => 'sometimes|min:10',
                'categories.*' => 'sometimes',
            ];

            $rules = array_merge($rules, $admin_rules);

        } else{

            $visitor_rules = [
                'email' => 'required',
            ];

            $rules = array_merge($rules, $visitor_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('newsletters');
        $local = getCurrentLocale();
        $attributes = [
            'email' => $field[$local]['email'] ?? __('newsletters.email'),
            'subject' => $field[$local]['subject'] ?? __('newsletters.subject'),
            'message' => $field[$local]['message'] ?? __('newsletters.message'),
        ];

        return $attributes;
    }
    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::json()){
//            $errors = (new ValidationException($validator))->errors();
            $errors = $validator->errors()->first();
            throw new HttpResponseException(response()->json(['errors' => $errors]));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
